<?php
/**
 * Tag Meta Community component for Joomla
 *
 * @author selfget.com (info@selfget.com)
 * @package TagMeta
 * @copyright Copyright 2009 - 2012
 * @license GNU Public License
 * @link http://www.selfget.com
 * @version 1.4.2
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.installer.installer');

global $plugin_path;
$plugin_path = $this->parent->getPath('source').DS.'plugin';
  
function com_install() {
  global $plugin_path;

  $db = & JFactory::getDBO();
  $db->debug(0);
  $e = true;

  $query = 'ALTER TABLE `#__tagmeta` CHANGE `title` `title` varchar(255) default NULL';
  $db->setQuery($query);
  if (!$db->query()) {
    echo('SQL "' . $query . '" failed');
    JError::raiseWarning(1, 'TagMetaInstaller::com_install(): '.JText::_( 'SQL Error' ).' '.$db->stderr(true));
    $e = false;
  }

  $query = 'ALTER TABLE `#__tagmeta` CHANGE `description` `description` varchar(255) default NULL';
  $db->setQuery($query);
  if (!$db->query()) {
    echo('SQL "' . $query . '" failed');
    JError::raiseWarning(1, 'TagMetaInstaller::com_install(): '.JText::_( 'SQL Error' ).' '.$db->stderr(true));
    $e = false;
  }

  $query = 'ALTER TABLE `#__tagmeta` CHANGE `keywords` `keywords` varchar(255) default NULL';
  $db->setQuery($query);
  if (!$db->query()) {
    echo('SQL "' . $query . '" failed');
    JError::raiseWarning(1, 'TagMetaInstaller::com_install(): '.JText::_( 'SQL Error' ).' '.$db->stderr(true));
    $e = false;
  }

  $query = 'ALTER TABLE `#__tagmeta` CHANGE `checked_out` `checked_out` int(11) unsigned NOT NULL default \'0\'';
  $db->setQuery($query);
  if (!$db->query()) {
    echo('SQL "' . $query . '" failed');
    JError::raiseWarning(1, 'TagMetaInstaller::com_install(): '.JText::_( 'SQL Error' ).' '.$db->stderr(true));
    $e = false;
  }

  $query = 'ALTER TABLE `#__tagmeta` ADD `author` varchar(255) default NULL AFTER `description`';
  $db->setQuery($query);
  if (!$db->query() && $db->getErrorNum() != '1060') {
    echo('SQL "' . $query . '" failed');
    JError::raiseWarning(1, 'TagMetaInstaller::com_install(): '.JText::_( 'SQL Error' ).' '.$db->stderr(true));
    $e = false;
  }

  $query = 'ALTER TABLE `#__tagmeta` ADD `canonical` varchar(255) default NULL AFTER `keywords`';
  $db->setQuery($query);
  if (!$db->query() && $db->getErrorNum() != '1060') {
    echo('SQL "' . $query . '" failed');
    JError::raiseWarning(1, 'TagMetaInstaller::com_install(): '.JText::_( 'SQL Error' ).' '.$db->stderr(true));
    $e = false;
  }

  $query = 'ALTER TABLE `#__tagmeta` ADD `comment` varchar(255) default NULL AFTER `rodp`';
  $db->setQuery($query);
  if (!$db->query() && $db->getErrorNum() != '1060') {
    echo('SQL "' . $query . '" failed');
    JError::raiseWarning(1, 'TagMetaInstaller::com_install(): '.JText::_( 'SQL Error' ).' '.$db->stderr(true));
    $e = false;
  }

  $query = 'ALTER TABLE `#__tagmeta` ADD `case_sensitive` tinyint(1) NOT NULL default \'1\' AFTER `comment`';
  $db->setQuery($query);
  if (!$db->query() && $db->getErrorNum() != '1060') {
    echo('SQL "' . $query . '" failed');
    JError::raiseWarning(1, 'TagMetaInstaller::com_install(): '.JText::_( 'SQL Error' ).' '.$db->stderr(true));
    $e = false;
  }

  $query = 'ALTER TABLE `#__tagmeta` ADD `hits` int(11) unsigned NOT NULL default \'0\' AFTER `case_sensitive`';
  $db->setQuery($query);
  if (!$db->query() && $db->getErrorNum() != '1060') {
    echo('SQL "' . $query . '" failed');
    JError::raiseWarning(1, 'TagMetaInstaller::com_install(): '.JText::_( 'SQL Error' ).' '.$db->stderr(true));
    $e = false;
  }

  $query = 'ALTER TABLE `#__tagmeta` ADD `last_visit` datetime NOT NULL DEFAULT \'0000-00-00 00:00:00\' AFTER `hits`';
  $db->setQuery($query);
  if (!$db->query() && $db->getErrorNum() != '1060') {
    echo('SQL "' . $query . '" failed');
    JError::raiseWarning(1, 'TagMetaInstaller::com_install(): '.JText::_( 'SQL Error' ).' '.$db->stderr(true));
    $e = false;
  }

  // Install plugin
  $installer = new JInstaller();
  if (!$installer->install($plugin_path)) {
    echo('Plugin System - Tag Meta installation failed: try to fix the problem and install the package again');
    JError::raiseWarning(1, 'TagMetaInstaller::com_install(): Plugin installation failed');
    $e = false;
  } else {
    echo('Plugin System - Tag Meta installed: remember to activate it <a href="index.php?option=com_plugins">here</a>');
  }

  return $e;
}

?>
